<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Negocios</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>Gestionar Negocios</strong>
      </div>
      <div class="supSec">Gestiona los Negocios o Crea uno Nuevo</div>
    </div>
    <div class="pl-10 pr-10 contSecc lighten-5">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col
            v-for="(negocio, indexNegocio) in negocios"
            :key="indexNegocio"
            :xs="12"
            :sm="12"
            :md="6"
            :lg="3"
          >
            <v-card class="generalCard pa-4">
              <div>
                <v-btn
                  x-small
                  class="float-left"
                  text
                  icon
                  @click="
                    showDialogDelete = true;
                    negocioToRemove = negocio;
                  "
                >
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/delete.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
                <v-btn :to="negocio.to" x-small class="float-right" text icon>
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    position="center"
                    src="@/assets/img/icoEditar.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
              </div>
              <v-card-text class="justify-center">
                <img
                  :src="negocio.path_logo"
                  :width="250"
                  height="150"
                  class="pa-0 ma-0"
                />
                <div>{{ negocio.descripcion }}</div>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAdd.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAdd.to"
            :color="cardAdd.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAdd.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAdd.src"
                :lazy-src="cardAdd.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
    </div>
    <template>
      <v-dialog v-model="showDialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este negocio?</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="showDialogDelete = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="preRemoveNegocio()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogDeleteConfirmacion" persistent max-width="700px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este negocio?</strong>
            </div>
            <div class="pa-4">
              El negocio
              <strong>{{
                negocioToRemove ? negocioToRemove.descripcion : ""
              }}</strong>
              esta asignado a las siguientes franquicias:
              <br />

              <v-chip
                v-for="(franquicia,
                indexFranquicia) in negocioToRemove.franquicias"
                :key="indexFranquicia"
                class="ma-2"
                >{{ franquicia.descripcion }}</v-chip
              >
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDeleteConfirmacion = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteNegocio"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<script>
import axios from "axios";
import Vuex from "vuex";
import { mapState } from "vuex";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const urlServicesPlataformaFranquicia =
  store.state.urlServicesPlataformaFranquicia;
export default {
  name: "Component-NegociosFranquicia",
  data() {
    return {
      showDialogDelete: false,
      dialogDeleteConfirmacion: false,
      cardAdd: {
        title: "Crear Negocio",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade un nuevo negocio.",
        to: {
          name: "modelo_franquicia_catalogos_negocios_nuevo"
        },
        color: "#494949"
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Franquicias",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_franquicias"
          }
        },
        {
          text: "Negocios",
          disabled: true
        }
      ],
      negocioToRemove: {},
      metadata: {},
      negocios: [],
      access_token: serviceLocalStorage.getAccessToken()
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    getNegocios() {
      var self = this;
      axios
        .get("/negocio/secure/get/")
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setNegocios(data);
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    setNegocios(data) {
      var self = this;
      if (data) {
        data = data.filter(itemNegocio => {
          if (itemNegocio.path_logo === "Sinlogo") {
            return itemNegocio;
          }
          if (itemNegocio.descripcion !== "GEK") {
            return itemNegocio;
          }
        });
        data.forEach(itemNegocio => {
          itemNegocio.to = {
            name: "modelo_franquicia_catalogos_negocios_edicion",
            params: {
              negocio: this.serviceCommons.objectToBase64(itemNegocio)
            }
          };
          itemNegocio.path_logo =
            urlServicesPlataformaFranquicia +
            "/file/secure/read/" +
            this.serviceCommons.stringToBase64(itemNegocio.path_logo) +
            "?access_token=" +
            this.access_token;
        });

        this.negocios = data;
      }
    },
    deleteNegocio() {
      var self = this;
      axios
        .delete("/negocio/secure/delete/", {
          data: self.negocioToRemove
        })
        .then(response => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data.deleted) {
                self.negocios = self.negocios.filter(
                  negocio =>
                    negocio.id_negocio !== self.negocioToRemove.id_negocio
                );
                this.showDialogDelete = false;
                this.dialogDeleteConfirmacion = false;
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },
    preRemoveNegocio() {
      if (this.negocioToRemove.franquicias.length > 0) {
        this.dialogDeleteConfirmacion = true;
        this.showDialogDelete = false;
      } else {
        this.deleteNegocio();
      }
    }
  },
  created() {
    this.getNegocios();
  }
};
</script>
